﻿Public Class CommonUtilities

    Public Function BrowseForZipFile() As String
        Try
            Dim ofd = New System.Windows.Forms.OpenFileDialog With {
                .AddExtension = True, .CheckFileExists = True, .DefaultExt = "zip",
                .Filter = "Zip Files (*.zip)|*.zip|All Files (*.*)|*.*",
                .FilterIndex = 0, .InitialDirectory = "C:\Temp\", .Multiselect = False,
                .ReadOnlyChecked = False, .RestoreDirectory = True,
                .ShowReadOnly = False, .Title = "Select Zip File", .ValidateNames = True}
            ofd.ShowDialog()
            Dim result = ofd.FileName
            Return result
        Catch ex As Exception
            Throw New Exception("CommonUtilities: BrowseForZipFile: Error: " & ex.Message, ex)
        End Try
    End Function

    Public Function BrowseForSourceFolder() As String
        Try
            Dim ofd = New System.Windows.Forms.FolderBrowserDialog With {
                .Description = "Browse for Zip Source Folder", .SelectedPath = "C:\Temp\", .ShowNewFolderButton = False}
            ofd.ShowDialog()
            Dim result = ofd.SelectedPath
            Return result
        Catch ex As Exception
            Throw New Exception("CommonUtilities: BrowseForSourceFolder: Error: " & ex.Message, ex)
        End Try
    End Function

    Public Function BrowseForExtractFolder() As String
        Try
            Dim ofd = New System.Windows.Forms.FolderBrowserDialog With {
                .Description = "Browse for Zip Extract Folder", .SelectedPath = "C:\Temp\", .ShowNewFolderButton = True}
            ofd.ShowDialog()
            Dim result = ofd.SelectedPath
            Return result
        Catch ex As Exception
            Throw New Exception("CommonUtilities: BrowseForExtractFolder: Error: " & ex.Message, ex)
        End Try
    End Function

    Private Sub DeleteDirectoryFiles(FolderPath As String)
        Try
            Dim files = New IO.DirectoryInfo(FolderPath).GetFiles
            For Each file In files
                System.IO.File.Delete(file.FullName)
            Next
        Catch ex As Exception
            Throw New Exception("CommonUtilities: DeleteDirectoryFiles: Error: " & ex.Message, ex)
        End Try
    End Sub

    Public Sub DeleteDirectoryContents(FolderPath As String)
        Try
            Call DeleteDirectoryFiles(FolderPath)
            Dim subFolders = New IO.DirectoryInfo(FolderPath).GetDirectories()
            For Each subFolder In subFolders
                Call DeleteDirectoryContents(subFolder.FullName)
                IO.Directory.Delete(subFolder.FullName)
            Next
        Catch ex As Exception
            Throw New Exception("CommonUtilities: DeleteDirectoryFiles: Error: " & ex.Message, ex)
        End Try
    End Sub
End Class
