﻿Public Class frmFramework40
    Dim zipfile40 As New ZipfileClass
    Dim utils As New CommonUtilities.CommonUtilities

    Private Sub ExitToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click
        Application.Exit()
    End Sub

    Private Sub AboutToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AboutToolStripMenuItem.Click
        MessageBox.Show("Visual Studio Magazine On VB article by Joe Kunk")
    End Sub

    Private Sub btnShowContents_Click(sender As Object, e As EventArgs) Handles btnShowContents.Click
        Call ShowContents(Me.txtZipFile.Text)
    End Sub

    Private Sub ShowContents(ZipFullFilename As String)
        Try
            If Not IO.File.Exists(ZipFullFilename) Then _
                Throw New IO.FileNotFoundException(
                    "ZipViaFramework40: frmFramework40: ShowContents: Error: ", ZipFullFilename)
            Dim result = zipfile40.GetZipDirectory(ZipFullFilename)
            Me.ListBox1.Items.Clear()
            For Each item In result
                Me.ListBox1.Items.Add(item)
            Next
        Catch ex As Exception
            Throw New Exception("ZipViaFramework40: frmFramework40: ShowContents: Error: " & ex.Message, ex)
        End Try
    End Sub

    Private Sub btnCreateZipFile_Click(sender As Object, e As EventArgs) Handles btnCreateZipFile.Click
        Dim optimization As IO.Packaging.CompressionOption = IO.Packaging.CompressionOption.Fast
        If rbMaximum.Checked Then optimization = IO.Packaging.CompressionOption.Maximum
        If rbNormal.Checked Then optimization = IO.Packaging.CompressionOption.Normal
        If rbNotCompressed.Checked Then optimization = IO.Packaging.CompressionOption.NotCompressed
        If rbSuperFast.Checked Then optimization = IO.Packaging.CompressionOption.SuperFast
        Call CreateZipFile(Me.txtZipFile.Text, Me.txtSourceFolder.Text, Optimization)
    End Sub

    Private Sub CreateZipFile(ZipFullFilename As String, FolderPath As String, Optimization As IO.Packaging.CompressionOption)
        Try
            If Not IO.Directory.Exists(FolderPath) Then _
                Throw New IO.DirectoryNotFoundException(
                    "ZipViaFramework40: frmFramework40: CreateZipFile: Error: " & FolderPath)
            Dim result = zipfile40.CreateZipFromFolder(ZipFullFilename, FolderPath, Optimization)
            Me.ListBox1.Items.Clear()
            Me.ListBox1.Items.Add(result)
        Catch ex As Exception
            Throw New Exception("ZipViaFramework40: frmFramework40: CreateZipFile: Error: " & ex.Message, ex)
        End Try
    End Sub

    Private Sub btnExtractZipFile_Click(sender As Object, e As EventArgs) Handles btnExtractZipFile.Click
        Call ExtractZipFile(Me.txtZipFile.Text, Me.txtExtractFolder.Text)
    End Sub

    Private Sub ExtractZipFile(ZipFullFilename As String, FolderPath As String)
        Try
            If Not IO.File.Exists(ZipFullFilename) Then _
                Throw New IO.FileNotFoundException(
                    "ZipViaFramework40: frmFramework40: ExtractZipFile: Error: ", ZipFullFilename)
            Dim result = zipfile40.ExtractZipToFolder(ZipFullFilename, FolderPath)
            Me.ListBox1.Items.Clear()
            Me.ListBox1.Items.Add(result)
        Catch ex As Exception
            Throw New Exception("ZipViaFramework40: frmFramework40: ExtractZipFile: Error: " & ex.Message, ex)
        End Try
    End Sub

    Private Sub frmFramework40_Load(sender As Object, e As EventArgs) Handles Me.Load
        Me.txtExtractFolder.Text = "C:\temp\Win8Zip\Extract40"
        Me.txtSourceFolder.Text = "C:\temp\Win8Zip\Source40"
        Me.txtZipFile.Text = "C:\temp\Win8Zip\Sample40_" & Now.Ticks.ToString & ".zip"
    End Sub

    Private Sub btnBrowseForZip_Click(sender As Object, e As EventArgs) Handles btnBrowseForZip.Click
        Me.txtZipFile.Text = utils.BrowseForZipFile()
    End Sub


End Class
