﻿Public Class frmFramework45
    Dim zipfile45 As New ZipfileClass
    Dim utils As New CommonUtilities.CommonUtilities


    Private Sub btnShowContents_Click(sender As Object, e As EventArgs) Handles btnShowContents.Click
        Call ShowContents(Me.txtZipFile.Text)
    End Sub

    Private Sub ShowContents(ZipFullFilename As String)
        Try
            If Not IO.File.Exists(ZipFullFilename) Then _
                Throw New IO.FileNotFoundException(
                    "ZipViaFramework45: frmFramework45: ShowContents: Error: ", ZipFullFilename)
            Dim result = zipfile45.GetZipDirectory(ZipFullFilename)
            Me.ListBox1.Items.Clear()
            For Each item In result
                Me.ListBox1.Items.Add(item)
            Next
        Catch ex As Exception
            Throw New Exception("ZipViaFramework45: frmFramework45: ShowContents: Error: " & ex.Message, ex)
        End Try
    End Sub

    Private Sub frmFramework45_Load(sender As Object, e As EventArgs) Handles Me.Load
        Me.txtExtractFolder.Text = "C:\temp\Win8Zip\Extract45"
        Me.txtSourceFolder.Text = "C:\temp\Win8Zip\Source45"
        Me.txtZipFile.Text = "C:\temp\Win8Zip\Sample45_" & Now.Ticks.ToString & ".zip"
    End Sub

    Private Sub btnCreateZipFile_Click(sender As Object, e As EventArgs) Handles btnCreateZipFile.Click
        Call CreateZipFile(Me.txtZipFile.Text, Me.txtSourceFolder.Text)
    End Sub

    Private Sub CreateZipFile(ZipFullFilename As String, FolderPath As String)
        Try
            If Not IO.Directory.Exists(FolderPath) Then _
                Throw New IO.DirectoryNotFoundException(
                    "ZipViaFramework45: frmFramework45: CreateZipFile: Error: " & FolderPath)

            Dim Optimization = IO.Compression.CompressionLevel.Fastest
            If rbLeastSize.Checked Then Optimization = IO.Compression.CompressionLevel.Optimal
            If rbNoCompression.Checked Then Optimization = IO.Compression.CompressionLevel.NoCompression
            Dim result = zipfile45.CreateZipFromFolder(ZipFullFilename, FolderPath, Optimization)

            Me.ListBox1.Items.Clear()
            Me.ListBox1.Items.Add(result)
        Catch ex As Exception
            Throw New Exception("ZipViaFramework45: frmFramework45: CreateZipFile: Error: " & ex.Message, ex)
        End Try
    End Sub

    Private Sub btnExtractZipFile_Click(sender As Object, e As EventArgs) Handles btnExtractZipFile.Click
        Call ExtractZipFile(Me.txtZipFile.Text, Me.txtExtractFolder.Text)
    End Sub

    Private Sub ExtractZipFile(ZipFullFilename As String, FolderPath As String)
        Try
            If Not IO.File.Exists(ZipFullFilename) Then _
                Throw New IO.FileNotFoundException(
                    "ZipViaFramework45: frmFramework45: ExtractZipFile: Error: ", ZipFullFilename)
            Dim result = zipfile45.ExtractZipToFolder(ZipFullFilename, FolderPath)
            Me.ListBox1.Items.Clear()
            Me.ListBox1.Items.Add(result)
        Catch ex As Exception
            Throw New Exception("ZipViaFramework45: frmFramework45: ExtractZipFile: Error: " & ex.Message, ex)
        End Try
    End Sub

    Private Sub btnBrowseForZip_Click(sender As Object, e As EventArgs) Handles btnBrowseForZip.Click
        Me.txtZipFile.Text = utils.BrowseForZipFile()
    End Sub

    Private Sub AboutToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AboutToolStripMenuItem.Click
        MessageBox.Show("Visual Studio Magazine On VB article by Joe Kunk")
    End Sub

    Private Sub ExitToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click
        Application.Exit()
    End Sub

    Private Sub btnBrowseForSourceFolder_Click(sender As Object, e As EventArgs) Handles btnBrowseForSourceFolder.Click
        Me.txtSourceFolder.Text = utils.BrowseForSourceFolder()
    End Sub

    Private Sub btnBrowseForExtractFolder_Click(sender As Object, e As EventArgs) Handles btnBrowseForExtractFolder.Click
        Me.txtExtractFolder.Text = utils.BrowseForExtractFolder()
    End Sub
End Class
