﻿Imports System.IO
Imports System.IO.Compression

Public Class ZipfileClass
    'Add a references to System.IO.Compression, System.IO.Compression.FileStream
    Dim utils As New CommonUtilities.CommonUtilities

    Public Function GetZipDirectory(ZipFullFilename As String) As List(Of String)
        Dim result As New List(Of String)
        Try
            Dim Message = "Name: {0}, Size: {1}, Original Size: {2}, Last Updated: {3}, FullName: {4}"
            Using zipfile = IO.Compression.ZipFile.OpenRead(ZipFullFilename)
                Dim zDirectory = zipfile.Entries()
                For Each item In zDirectory
                    Dim dirMessage = String.Format(Message, item.Name, item.CompressedLength, item.Length, item.LastWriteTime, item.FullName)
                    result.Add(dirMessage)
                Next
            End Using
        Catch ex As Exception
            Throw New Exception("ZipViaFramework45: ZipfileClass: GetZipDirectory: Error: " & ex.Message, ex)
        End Try
        Return result
    End Function

    Public Function ExtractZipToFolder(ZipFullFilename As String, FolderPath As String) As String
        'Returns status message to display
        Try
            If Not IO.File.Exists(ZipFullFilename) Then _
                Throw New IO.FileNotFoundException(
                    "ZipViaFramework45: ZipfileClass: ExtractZipToFolder: Error: ", ZipFullFilename)

            If Not IO.Directory.Exists(FolderPath) Then _
                IO.Directory.CreateDirectory(FolderPath)

            Dim itemCount = New IO.DirectoryInfo(FolderPath).GetFiles().Count + New IO.DirectoryInfo(FolderPath).GetDirectories.Count
            If itemCount > 0 Then
                'Enable this if you are comfortable to clear the folder before extracting to it
                'Call utils.DeleteDirectoryContents(FolderPath)
            End If

            IO.Compression.ZipFile.ExtractToDirectory(ZipFullFilename, FolderPath)
        Catch ex As Exception
            Throw New Exception("ZipViaFramework45: ZipfileClass: ExtractZipToFolder: Error: " & ex.Message, ex)
        End Try
        Dim message = String.Format("Extracted zip file: {0} to folder {1}", ZipFullFilename, FolderPath)
        Return message
    End Function

    Public Function CreateZipFromFolder(ZipFullFilename As String, FolderPath As String, Optimization As IO.Compression.CompressionLevel) As String
        'Returns status message to display
        Try
            If IO.Directory.Exists(FolderPath) = False Then _
                Throw New IO.DirectoryNotFoundException(
                    "ZipViaFramework45: ZipfileClass: CreateZipFromFolder: Error: " & FolderPath)

            If IO.File.Exists(ZipFullFilename) Then _
                IO.File.Delete(ZipFullFilename)

            IO.Compression.ZipFile.CreateFromDirectory(FolderPath, ZipFullFilename, Optimization, includeBaseDirectory:=False)
        Catch ex As Exception
            Throw New Exception("ZipViaFramework45: ZipfileClass: ExtractZipToFolder: Error: " & ex.Message, ex)
        End Try
        Dim message = String.Format("Created zip file: {0} from folder {1}", ZipFullFilename, FolderPath)
        Return message
    End Function
End Class



